/*
 * Created by SharpDevelop.
 * User: ata
 * Date: 14.12.2006
 * Time: 00:06
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Collections.Generic;

namespace vigenere
{
	class MainClass
	{
		
		static char[,] vigenere_table = new char[26,26];
		static char[,] s_vigenere_table = new char[26,26];
		
		public static void create_vigenere_table(int k) {
			int i,s;
			for(i=0;i<26;i++) {
				for(s=0;s<26;s++) {
					vigenere_table[i,s] = Convert.ToChar(65+(s+i+k)%26);
					s_vigenere_table[i,s] = Convert.ToChar(97+(s+i+k)%26);
			
				}		
			}	
		}
		public static  string encrypt(string text,string key) {
	
			int i;
			string tmp="";
			char keyChar_U;
			char keyChar_L;	
			
			for(i=0;i<text.Length;i++){
		
				keyChar_U= Convert.ToChar(key[i%key.Length].ToString().ToUpper());
				keyChar_L= Convert.ToChar(key[i%key.Length].ToString().ToLower());
								
				if((int)text[i]>96 && (int)text[i] <123) {
					tmp+=Convert.ToString(s_vigenere_table[(int)keyChar_L-97,(int)text[i]-97]);
				}else if ((int)text[i]>64 && (int)text[i] <91){
					tmp+=Convert.ToString(vigenere_table[(int)keyChar_U-65,(int)text[i]-65]);
				}else {
					tmp+=Convert.ToString(text[i]);
				}
		
			}	
			
			return tmp;
		}

		public static string decrypt(string text,string key) {
	
			int i,s;
			string tmp = "";
			char keyChar_U;
			char keyChar_L;

			for(i=0;i<text.Length;i++){
		
				keyChar_U= Convert.ToChar(key[i%key.Length].ToString().ToUpper());
				keyChar_L= Convert.ToChar(key[i%key.Length].ToString().ToLower());

				if((int)text[i]>96 && (int)text[i] <123) {
					for(s=0;s<26;s++) {
						if(text[i] == vigenere_table[(int)keyChar_L-97,s]) {
							tmp+= (char)(97 + s % 26);
							break;
						}
					}		
				}else if ((int)text[i]>64 && (int)text[i] <91){
					for(s=0;s<26;s++) {
						if(text[i] == vigenere_table[(int)keyChar_U-65,s]) {
							tmp+= (char)(65 + s % 26);
							break;
						}
					}
				}else {
					tmp+= text[i];
				}
		
			}
			
			return tmp;
		}

		public static void Main(string[] args)
		{
			create_vigenere_table(0);
			Console.WriteLine("Plain Text   :" + decrypt(encrypt("ATTACKATDAWN","LEMON"),"LEMON"));
			Console.WriteLine("Key          :LEMON");
			Console.WriteLine("Cipher Text  :"+encrypt("ATTACKATDAWN","LEMON"));
			Console.Read();
		}
	}
}
